import java.awt.*;
import javax.swing.*;
import java.applet.*;

public class Koch extends Applet {
  public static int a = 400;
  public static double visina = Math.sqrt(3.0)/2.0;

  //pomozna funkcija, ki narise trikotnik z levim sp. ogljiscem v (x,y) in stranico a
  public static void crta(Graphics g, int x1, int y1, int x2, int y2) {
    g.drawLine(x1,y1,x2,y2);
  }

  //narise snezaka stopnje stopnja. (x,y) sta koordinati sredisca glavnega kroga,
  //radij pa njegov polmer
  public static void kochovaSnezinka(Graphics g, int x1, int y1, int x2, int y2, int stopnja) {
    if(stopnja == 0) {
      crta(g, x1, y1, x2, y2); // izris trikotnika na nictem nivoju
    }
    else {
      int xm1 = x1+(x2-x1)/3;
      int ym1 = y1+(y2-y1)/3;

      // pri danem vektorju (x,y) je vektor (y,-x) nanj ravno pravokoten
      int xm2 = (int)(x1+(x2-x1)/2+(y2-y1)*visina/3);
      int ym2 = (int)(y1+(y2-y1)/2-(x2-x1)*visina/3);

      int xm3 = x2 - (x2-x1)/3;
      int ym3 = y2 - (y2-y1)/3;

      kochovaSnezinka(g,x1,y1,xm1,ym1,stopnja-1);
      kochovaSnezinka(g,xm1,ym1,xm2,ym2,stopnja-1);
      kochovaSnezinka(g,xm2,ym2,xm3,ym3,stopnja-1);
      kochovaSnezinka(g,xm3,ym3,x2,y2,stopnja-1);
    }
  }

  public void paint(Graphics g)  {
    kochovaSnezinka(g, 50, 150, 450, 150, 5); //narisi eno Kochovo snezinko
    kochovaSnezinka(g, 450, 150, 250, (int)(150+400*visina), 5); // in jo dopolni
    kochovaSnezinka(g, 250, (int)(150+400*visina), 50, 150, 5); // v sklenjeno
  }
}